#ifdef _WIN32
	#include <windows.h>
	#include <gl/glut.h>
#else
	#include "glwrap.h"
#endif

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define Red {1, 0, 0, 1}
#define Blue {0, 0, 1, 1}
#define Green {0, 1, 0, 1}
#define White {1, 1, 1, 1}
#define Yellow {1, 1, 0, 1}
#define Purple {1, 0, 1, 1}
#define Black {0.15, 0.15, 0.15, 1}
#define N_SHUFFLE 25

#define KEY_LEFT                VK_LEFT
#define KEY_RIGHT               VK_RIGHT
#define KEY_UP                  VK_UP
#define KEY_DOWN                VK_DOWN

#define KEY_SPACE               VK_SPACE
#define KEY_PLUS                0xBB 
#define KEY_MINUS               0xBD

typedef enum
{
    KEY_0 = 0x30,
    KEY_1,
    KEY_2,
    KEY_3,
    KEY_4,
    KEY_5,
    KEY_6,
    KEY_7,
    KEY_8,
    KEY_9
}TypeNumbericKeyDefine;

typedef enum
{
    KEY_A   = 0x41,
    KEY_B,
    KEY_C,
    KEY_D,
    KEY_E,
    KEY_F,
    KEY_G,
    KEY_H,
    KEY_I,
    KEY_J,
    KEY_K,
    KEY_L,
    KEY_M,
    KEY_N,
    KEY_O,
    KEY_P,
    KEY_Q,
    KEY_R,
    KEY_S,
    KEY_T,
    KEY_U,
    KEY_V,
    KEY_W,
    KEY_X,
    KEY_Y,
    KEY_Z
}TypeAlphaKeyDefine;
